
/*
 * Function return vals
 */

extern unsigned int __get_DS();
extern long dos_getvect();
extern void dos_setvect();
extern unsigned int elks_int();
extern unsigned int run_cpu();

/*
 *	Elks binary formats
 */
 
#define EXEC_HEADER_SIZE	32

struct elks_exec_hdr
{
	unsigned long type;
#define ELKS_COMBID	0x04100301L
#define ELKS_SPLITID	0x04200301L	
	unsigned long hlen;
	unsigned long tseg;
	unsigned long dseg;
	unsigned long bseg;
	unsigned long unused;
	unsigned long chmem;
	unsigned long unused2; 
};

/*
 * Elks cpu structure.
 */

struct irq_stack
{
   unsigned int ax;	/* NOTE The order of this is _closely_ related to */
   unsigned int bx;	/* the coroutine assembler */
   unsigned int cx;
   unsigned int dx;
   unsigned int di;
   unsigned int si;
   unsigned int bp;
   unsigned int es;

   unsigned int ds;	/* start +16 +0 */
   unsigned int pc;	/* start +16 +2 */
   unsigned int cs;	/* start +16 +4 */
   unsigned int flgs;	/* start +16 +6 */
   unsigned int ss;	/* start +16 +8 */
   unsigned int sp;	/* start +16 +10 */
};

extern struct irq_stack elks_regs;
extern unsigned int current_ds, current_stack;

/*
 * Elks syscall interface
 */

#define ELKSINT   0x80
typedef int (*Scallp)( /* int, int, int */ );
#define MAXSYSCALL 80
extern Scallp syscalltab[MAXSYSCALL];

/******************************************************************************/

#ifndef ENOSYS
#define ENOSYS 38
#endif

#ifndef MSDOS
#define interrupt
#define far
#define huge
#endif

#ifndef O_BINARY
#define O_BINARY 0
#endif

