#include <stdio.h>
#include <ctype.h>
#include <dos.h>
#include <malloc.h>
#include <errno.h>
#include <fcntl.h>

#include "doselks.h"
#include "syscalls.h"

/***************************************************************************/

/* Is the terminal in text or bin mode ? */
int tty_mode[3] = {1, 1, 1};

#define sys_exit elks_exit
int elks_exit(bx, cx, dx)
int bx, cx, dx;
{
extern int process_running;
extern int exit_code;

   process_running = 0;
   exit_code = bx;
   return bx;
}

#define sys_read elks_read
int elks_read(bx, cx, dx)
int bx, cx, dx;
{
#asm
  mov	bx,sp
  mov	cx,[bx+6]
  mov	dx,[bx+4]
  mov	bx,[bx+2]
  mov	ah,#$3f
  push	ds
  push	es
  pop	ds
  int	#$21
  pop	ds
  jnc	readok
  mov	ax,#-1
readok:

#endasm
}

int elks_far_write(bx, cx, dx)
int bx, cx, dx;
{
#asm
  mov	bx,sp
  mov	cx,[bx+6]
  mov	dx,[bx+4]
  mov	bx,[bx+2]
  mov	ah,#$40
  push	ds
  push	es
  pop	ds
  int	#$21
  pop	ds
  jnc	writeok
  mov	ax,#-1
writeok:

#endasm
}

#define sys_write elks_write
int elks_write(bx, cx, dx)
unsigned int bx, cx, dx;
{
   char ch[2];
   register unsigned int i;
   if( bx > 2 || tty_mode[bx] == 0 ) return elks_far_write(bx, cx, dx);

   /* Slooooooow but who cares! I suppose we could use a little buffer ... */
   for(i=dx; i>0; i--)
   {
      if( (ch[0]= __peek_es(cx++)) == '\n' )
           write(bx, "\r\n", 2);
      else write(bx, ch, 1);
   }
   return dx;
}


/***************************************************************************/

#define sys_enosys elks_enosys
int elks_enosys(bx, cx, dx)
int bx, cx, dx;
{
   return -ENOSYS;
}

#include "defn_tab.v"

Scallp syscalltab[] = {
#include "call_tab.v"
   elks_enosys
};

run_executable()
{
   register unsigned int r_ax;
   register Scallp ptr;
   process_running=1;
   do
   {
      if( (r_ax = run_cpu()) >= sizeof(syscalltab)/sizeof(Scallp) )
         elks_regs.ax = -ENOSYS;
      else
         elks_regs.ax =
	    (*syscalltab[r_ax])(elks_regs.bx, elks_regs.cx, elks_regs.dx);
   }
   while(process_running);
}
